package cn.yyxx.commsdk.platform.hnyy.fragment.fragment;

import android.app.Activity;
import android.app.Fragment;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;



import cn.yyxx.commsdk.core.utils.ResourceUtil;
import cn.yyxx.commsdk.platform.hnyy.fragment.fragment.widget.TosUtil;

public class UserRetrievePwdFragment extends BaseFragment {

    private EditText et_user_phone,et_user_code,et_user_pwd;
    private Button btn_get_code,reg_compete_btn;
    private ImageButton close_btn;

    private TextView tv_tip_2;

    private TimeCount timer;
    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(ResourceUtil.getLayoutId(getActivity(),"hnyy_retrieve_pwd"), container, false);
        view.setClickable(true);

        return view;
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        et_user_phone = view.findViewById(ResourceUtil.getId(getActivity(), "et_user_phone"));
        et_user_code = view.findViewById(ResourceUtil.getId(getActivity(), "et_user_code"));
        et_user_pwd  = view.findViewById(ResourceUtil.getId(getActivity(), "et_user_pwd"));
        btn_get_code  = view.findViewById(ResourceUtil.getId(getActivity(), "btn_get_code"));
        reg_compete_btn  = view.findViewById(ResourceUtil.getId(getActivity(), "reg_compete_btn"));

        tv_tip_2 = view.findViewById(ResourceUtil.getId(getActivity(), "tv_tip_2"));
        tv_tip_2.setOnClickListener(this);
        close_btn  = view.findViewById(ResourceUtil.getId(getActivity(), "close_btn"));

        btn_get_code.setOnClickListener(this);
        close_btn.setOnClickListener(this);
        reg_compete_btn.setOnClickListener(this);

        timer = new TimeCount(60000, 1000);
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);

        int id = v.getId();
        if (id == ResourceUtil.getId(getActivity(), "btn_get_code")) {
            String phone =  et_user_phone.getText().toString();

            if (phone.length() < 10) {
                new TosUtil(getActivity(),TosUtil.TOAST_ERROR, getString(ResourceUtil.getStringId(getActivity(), "hnyy_pls_input_right_phone"))).show();
                return;
            }
            getPhoneCaptcha(getActivity(),phone,"modify_pwd");
        }else if (id == ResourceUtil.getId(getActivity(), "reg_compete_btn")) {
            String phone =  et_user_phone.getText().toString();
            String code = et_user_code.getText().toString();
            String pwd = et_user_pwd.getText().toString();
            if (phone.length() < 10) {

                new TosUtil(getActivity(),TosUtil.TOAST_ERROR,getString(ResourceUtil.getStringId(getActivity(), "hnyy_pls_input_right_phone"))).show();

                return;
            }
            if(code.length() < 4 || TextUtils.isEmpty(code))
            {
                new TosUtil(getActivity(),TosUtil.TOAST_ERROR,getString(ResourceUtil.getStringId(getActivity(), "hnyy_pls_input_right_code"))).show();


                return;
            }
            if(pwd.length() < 6 || TextUtils.isEmpty(pwd))
            {
                new TosUtil(getActivity(),TosUtil.TOAST_ERROR, getString(ResourceUtil.getStringId(getActivity(), "hnyy_pwd_limit_6"))).show();

                return;
            }
            resetPwdWithPhone(getActivity(),phone,code,pwd);

        }else if (id == ResourceUtil.getId(getActivity(), "close_btn")) {

            Fragment accountLoginFragment = FragmentUtils.getSdkFragment(getActivity(),FragmentUtils.SDK_LOGIN_TAG);
            replaceFragmentToActivity(getFragmentManager(),accountLoginFragment,ResourceUtil.getId(getActivity(),"hnyy_content"));

        }else if (id == ResourceUtil.getId(getActivity(), "tv_tip_2")) {

        }

    }


    private void  getPhoneCaptcha(Activity activity, String phone, String action){

    }


    private void getCodeSuccess() {
        btn_get_code.setEnabled(false);
        btn_get_code.setText("60s");


        timer.start();
    }

    class TimeCount extends CountDownTimer {

        public TimeCount(long millisInFuture, long countDownInterval) {
            super(millisInFuture, countDownInterval);
            // TODO Auto-generated constructor stub
        }

        @Override
        public void onTick(long millisUntilFinished) {
            // TODO Auto-generated method stub
            btn_get_code.setText(millisUntilFinished / 1000 + "s");

        }

        @Override
        public void onFinish() {
            // TODO Auto-generated method stub
            btn_get_code.setEnabled(true);
            btn_get_code.setText(ResourceUtil.getStringId(getActivity(), "hnyy_get_phone_code"));
        }

    }
    public interface ResetPwdCallback {

        void onResetSuccess(String msg);
        void onResetFailed(String msg);


    }

    private void resetPwdWithPhone(final Activity activity, final String phone, String code, final String pwd) {

    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        if (timer != null){
            timer.cancel();
        }

    }
}
